#!/usr/bin/env python
# -*- coding: utf-8 -*-

# author: Pocholo
# date: 4/1/21

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugins folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY# without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.   

from gimpfu import *
import gettext
import os, sys,time 

gettext.install("gimp20", gimp.locale_directory, unicode=True)

def pm_create_a_happy_easter_design():
        
    #Initiates the temporary state
    pdb.gimp_context_set_defaults()
    pdb.gimp_context_set_default_colors()
	
	#Create the background sky
    img = pdb.gimp_image_new(2000, 1400, RGB)
    backLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB_IMAGE, "Sky", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(backLayer)
    pdb.gimp_image_add_layer(img, backLayer, 0)
    pdb.gimp_context_set_foreground("White")   
    pdb.gimp_drawable_fill(backLayer, FILL_FOREGROUND)
    pdb.gimp_context_set_gradient("Blue Green")
    pdb.gimp_drawable_edit_gradient_fill(backLayer,                                  
                                                 0,  #gradient type - linear         
                                                 0,  #offset
                                              TRUE,  #supe-samle
                                                 3,  #supersample_max_depth
                                              0.20,  #threshold 
                                              TRUE,  #dither                                                 
                                              1000,  #x1
                                              -145,  #y1
                                              1000,  #x2
                                              1400)  #y2
    
    #Show process
    pdb.gimp_display_new(img)
    
    #Clouds
    cloudsLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Clouds", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, cloudsLayer, 0)
    pdb.gimp_layer_add_alpha(cloudsLayer)
    pdb.gimp_drawable_fill(cloudsLayer, FILL_TRANSPARENT)
    pdb.gimp_image_select_rectangle(img, 2, 0, 0, 2000, 800)
    pdb.gimp_context_set_foreground("White")
    pdb.gimp_edit_bucket_fill(cloudsLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.plug_in_solid_noise(img, cloudsLayer, FALSE, FALSE, 3, 5, 3.5, 3.5)
    pdb.plug_in_colortoalpha(img, cloudsLayer, "Black")
    pdb.plug_in_gauss(img, cloudsLayer, 40, 40, 1)
    pdb.gimp_selection_none(img)
		
	#Fence	
    fenceLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Fence", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, fenceLayer, 0)
    pdb.gimp_layer_add_alpha(fenceLayer)
    pdb.gimp_drawable_fill(fenceLayer, FILL_TRANSPARENT)
    pdb.gimp_image_select_rectangle(img, 2, 0, 640, 2000, 750)
    pdb.gimp_context_set_pattern("Wood board natural.jpg")
    pdb.gimp_edit_bucket_fill(fenceLayer, BUCKET_FILL_PATTERN, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    #3d extrusion
    pdb.script_fu_3d_extrude(img, fenceLayer, 
                                            0,  #extrusion type 
                                           20,  #extrusion depth 
                                          270,  #extrusion direction 
                                          145,  #bump azimuth 
                                           45,  #bump elevation 
                                            1,  #bump depth 
                                         0.30,  #bump ambient light 
                                            0,  #bump curve 
                                        FALSE,  #invert bump 
                                         TRUE,  #merge extrusion 
                                        FALSE,  #overlay with pattern 
                                        FALSE,  #extrude with pattern 
                                  "Dried mud")  #extrision pattern)
    extrusion = pdb.gimp_image_get_layer_by_name(img, "Extrusion")
    pdb.gimp_item_set_name(extrusion, "Fence")
    
    #Left ear
    ear1Layer = pdb.gimp_layer_new(img, img.width, img.height, RGB_IMAGE, "Left ear", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(ear1Layer)
    pdb.gimp_image_add_layer(img, ear1Layer, 1)
    pdb.gimp_drawable_fill(ear1Layer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground("White")
    pdb.gimp_context_set_gradient_fg_bg_rgb()
    pdb.gimp_brushes_set_brush("2. Hardness 100")
    pdb.gimp_context_set_brush_size(400)
    pdb.gimp_context_set_brush_aspect_ratio(-3.50)
    pdb.gimp_context_set_brush_angle(10)
    pdb.gimp_context_set_brush_spacing(0.10)
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_paintbrush_default(ear1Layer, 2, [1125, 545])
    
    #Text copy inner Glow                           
    pdb.python_layerfx_inner_glow(img, ear1Layer,
								 (238, 179, 232),   #color
								             100,   #opacity
								               4,   #contou - linear
								               0,   #noise
                                               3,   #mode - multiply
                                               1,   #source
                                              25,   #choke
                                              30,   #size
                                            TRUE)   #merge
    ear1Layer = pdb.gimp_image_get_layer_by_name(img, "Left ear")
    
    #Inner Glow								   
    pdb.python_layerfx_outer_glow(img, ear1Layer, 
									(94, 75, 84),   #color
											  20,   #opacity
									 		   0,   #contou
											   0,   #noise
								               3,   #mode - multiply
											   0,   #spread 
											  10,   #size 
										    TRUE,   #knockout
                                            TRUE)   #merge
    ear1Layer = pdb.gimp_image_get_layer_by_name(img, "Left ear")
    
    #Right ear
    non_empty = pdb.gimp_edit_copy(ear1Layer)
    ear2Layer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Right ear", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_insert_layer(img, ear2Layer, None, 1)
    pdb.gimp_layer_add_alpha(ear2Layer)
    ear2Layer = pdb.gimp_edit_paste(ear2Layer, FALSE)
    pdb.gimp_floating_sel_anchor(ear2Layer) 
    ear2Layer = pdb.gimp_image_get_layer_by_name(img, "Right ear")
    ear2Layer = pdb.gimp_item_transform_flip_simple(ear2Layer, ORIENTATION_HORIZONTAL, TRUE, 0) 
    pdb.gimp_layer_resize_to_image_size(ear1Layer)
    pdb.gimp_layer_resize_to_image_size(ear2Layer)
        
    #Fold on right ear
    ear1Layer = pdb.gimp_image_get_layer_by_name(img, "Left ear")
    ear1Layer = pdb.gimp_item_transform_translate(ear1Layer, -30, 0)
    ear2Layer = pdb.gimp_item_transform_translate(ear2Layer, 30, 42) 
    pdb.gimp_layer_resize_to_image_size(ear1Layer)
    pdb.gimp_layer_resize_to_image_size(ear2Layer)
    foldLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB_IMAGE, "Fold right ear", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(foldLayer)
    pdb.gimp_image_add_layer(img, foldLayer, 1)
    pdb.gimp_drawable_fill(foldLayer, FILL_TRANSPARENT)
    pdb.gimp_image_select_item(img, 2, ear2Layer)
    pdb.gimp_selection_grow(img, 25)    
    pdb.gimp_context_set_foreground("White")
    pdb.gimp_brushes_set_brush("2. Hardness 100")
    pdb.gimp_context_set_brush_size(300)
    pdb.gimp_context_set_brush_aspect_ratio(-3.00)
    pdb.gimp_context_set_brush_angle(5)
    pdb.gimp_context_set_brush_spacing(0.10)
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_paintbrush_default(foldLayer, 2, [870, 360])
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_ellipse(img, 2, 786, 408, 185, 185)
    pdb.gimp_selection_invert(img)
    pdb.gimp_drawable_edit_clear(foldLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_ellipse(img, 2, 654, 408, 453, 483)
    pdb.gimp_selection_invert(img)
    pdb.gimp_drawable_edit_clear(ear2Layer)
    pdb.gimp_selection_none(img)
    
    #Drop Shadow
    pdb.python_layerfx_drop_shadow(img, foldLayer,
								        ("Black"),   #color
											  20,   #opacity
												0,   #contou - linear
												0,   #noise
												3,   #mode - multiply   
												0,   #spread
											    10,   #size
											  110,   #offset_angle
											    5,   #offset_distance
											 TRUE,   #knockout
											 TRUE)   #merge
    foldLayer = pdb.gimp_image_get_layer_by_name(img, "Fold right ear")
    
    #Text inner shadow
    pdb.python_layerfx_inner_shadow(img, foldLayer, 
                                         ("Black"),   #color
                                                50,   #opacity
                                                 0,   #contou linear
                                                 0,   #noise
                                                21,   #mode - grain merge
                                                 1,   #source
                                                 0,   #choke 
                                                30,   #size 
                                               100,   #offset_angle 
                                                10,   #offset_distance 
                                              TRUE)  #merge
    foldLayer = pdb.gimp_image_get_layer_by_name(img, "Fold right ear")
        
    #Merge both ears    
    ear2Layer = pdb.gimp_image_merge_down(img, ear2Layer, CLIP_TO_IMAGE)
    foldLayer = pdb.gimp_image_merge_down(img, foldLayer, CLIP_TO_IMAGE)
    ear1Layer = pdb.gimp_image_get_layer_by_name(img, "Left ear")   
    pdb.gimp_item_set_name(ear1Layer, "Bunny ears")
    
    #Grass
    grassLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB_IMAGE, "Grass", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(grassLayer)
    pdb.gimp_image_add_layer(img, grassLayer, 0)
    pdb.gimp_drawable_fill(grassLayer, FILL_TRANSPARENT)
    pdb.gimp_image_select_ellipse(img, 2, 0, 1375, 2000, 25)
    pdb.plug_in_sel2path(img, grassLayer)   
    pdb.gimp_selection_none(img)
    pdb.gimp_context_set_foreground((21, 64, 8))
    pdb.gimp_context_set_background((140, 212, 87))
    pdb.gimp_context_set_gradient_fg_bg_rgb()
    pdb.gimp_brushes_set_brush("Grass brush animated 1")
    pdb.gimp_context_set_brush_size(150)
    pdb.gimp_context_set_brush_angle(0)
    pdb.gimp_context_set_brush_spacing(0.30)
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_context_set_dynamics("Random Size/Color")
    pdb.gimp_context_set_stroke_method (STROKE_PAINT_METHOD)
    vectors = pdb.gimp_image_get_vectors_by_name(img, _("Selection"))   
    pdb.gimp_drawable_edit_stroke_item(grassLayer, vectors)
	
	#Repeat the grass stroke	
    for item in range(1,30):
        pdb.gimp_drawable_edit_stroke_item(grassLayer, vectors)

    pdb.gimp_context_set_dynamics("Dynamics Off")

    #Tulips
    tulipsLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB_IMAGE, "Tulips", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(tulipsLayer)
    pdb.gimp_image_add_layer(img, tulipsLayer, 1)
    pdb.gimp_drawable_fill(tulipsLayer, FILL_TRANSPARENT)
    pdb.gimp_brushes_set_brush("Animated Tulips")
    pdb.gimp_context_set_brush_size(280)
    pdb.gimp_context_set_brush_angle(0)
    pdb.gimp_context_set_brush_spacing(1.00)
    pdb.gimp_context_set_dynamics("Dynamics Off")
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_paintbrush_default(tulipsLayer, 4, [-150, 1200, 2000, 1200])
    pdb.gimp_context_set_brush_spacing(1.50)
    pdb.gimp_paintbrush_default(tulipsLayer, 4, [-150, 1200, 2000, 1200])
    pdb.gimp_context_set_brush_spacing(0.50)
    pdb.gimp_paintbrush_default(tulipsLayer, 4, [-150, 1220, 2000, 1220])
    pdb.gimp_context_set_brush_spacing(0.85)
    pdb.gimp_paintbrush_default(tulipsLayer, 4, [-150, 1220, 2000, 1220])     
    
    #Eggs
    eggsLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB_IMAGE, "Eggs", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(eggsLayer)
    pdb.gimp_image_add_layer(img, eggsLayer, 0)
    pdb.gimp_drawable_fill(eggsLayer, FILL_TRANSPARENT)
    pdb.gimp_brushes_set_brush("Easter Eggs")
    pdb.gimp_context_set_brush_size(150)
    pdb.gimp_context_set_brush_angle(0)
    pdb.gimp_context_set_brush_spacing(1.50)
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_context_set_dynamics("Directional")
    pdb.gimp_paintbrush_default(eggsLayer, 4, [0, 1300, 2000, 1300])
       
    #Eggs shadow
    pdb.script_fu_perspective_shadow(img, eggsLayer, 
	                                             90,   #angle
											    22,  #relative dist from horizon
											    0.3,  #relative length fron shadow
												 35,  #blur radius
											"black",  #color
												 80,  #opacity
												  1,  #interpolation
											  FALSE)  #allow resizing   
        
    backLayer = pdb.gimp_image_get_layer_by_name(img, "Sky")
    pdb.gimp_image_set_active_layer(img, backLayer)
    pdb.gimp_context_set_defaults()
    pdb.gimp_context_set_default_colors()
    pdb.gimp_context_set_dynamics("Dynamics Off")
    	
register(
    "pm_create_a_happy_easter_design",
    "Creates a nice Easter Design",
    "Creates a nice Easter Design",
    "Pocholo",
    "Pocholo",
    "2021",
    "Create a Happy Easter Design",
    "",
    [        
    ],
    [],
    pm_create_a_happy_easter_design, menu="<Image>/Pocholo-scripts/Create a Happy Easter Design",
    domain=("gimp20", gimp.locale_directory))
main()					